/*
   See page 132 of "Learning C++", Third Edition, by Eric Nagler.

   This demonstrates all of the ways a copy constructor would be activated
   (in an assignment, in call by value, and in a function return).

   C does not have copy constructors, but it is very informative to look at
   the assembly code and see how C handles the equivalent situations.

   Also, you can change the extension of this program from .c to .cpp and then
   recompile it as a C++ program and see what changes in the assembly code.
*/

typedef struct
{
   int data1;
   int data2;
   char data3[5];
} T;

T someFunction(T arg)
{
   return arg;
}

int main()
{
   T instance1 = {1357, 2468, "hello"};
   T instance2 = someFunction(instance1);
   T instance3 = instance2;

   return 0;
}
