/*
    Compile using gcc.

    Use the command
    c:\mingw\bin\gcc -o tail-factorial.exe tail-factorial.c
    to compile this program without tail recursion optimization.
    The program will crash when it runs.

    Use the command
    c:\mingw\bin\gcc -S tail-factorial.c
    to get the assembly language listing tail-factorial.s.

    Use the command
    c:\mingw\bin\gcc -O2 -o tail-factorial.exe tail-factorial.c
    to compile this program with tail recursion optimization.

    Use the command
    c:\mingw\bin\gcc -S -O2 tail-factorial.c
    to get the optimized assembly language listing.
*/
#include <stdio.h>

double tail_factorial(double accumulator, double x)
{
   if (x < 1.0)
     return accumulator;
   else
     return tail_factorial(x * accumulator, x - 1);
}

int main()
{
   double x = 1000000.0; // large enough to overflow the stack
   printf("tail_factorial(1,%e) = %e", x, tail_factorial(1,x));
   return 0;
}
